import { A as AnyBaseNode, U as UnionNode, N as NullNode, a as UndefinedNode, b as AnyNode, c as AnyObjectNode, P as Primitive } from './complex-90b7ed01.js';
export { g as AnyArrayNode, Q as AnyCustomNode, J as AnyFormDataNode, G as AnyFormDataShape, t as AnyFunctionNode, D as AnyIntersectionNode, j as AnyIteratorNode, ac as AnyLiteralNode, p as AnyMapNode, Z as AnyNamedNode, e as AnyObjectShape, m as AnyRecordKeyNode, n as AnyRecordNode, l as AnySetNode, x as AnyTupleNode, ag as AnyTypeNode, v as AnyUnionNode, f as ArrayNode, B as BaseNode, am as BigIntNode, as as BlobNode, a5 as BooleanNode, $ as CircularNode, L as CustomNode, C as CustomTypeNode, ao as DateNode, W as DefinitionReferenceNode, aq as FileNode, H as FormDataNode, F as FunctionNode, I as Infer, z as IntersectionNode, i as IteratorNode, ab as LiteralNode, M as MapNode, Y as NamedNode, ai as NeverNode, a3 as NumberNode, O as ObjectNode, R as RecordNode, ak as RegexpNode, S as SetNode, a1 as StringNode, au as SymbolNode, T as TupleNode, ae as UnknownNode, a9 as VoidNode, ah as any, h as array, an as bigint, at as blob, a6 as boolean, a0 as circular, V as custom, ap as date, d as defineNode, X as definitionReference, ar as file, K as formData, u as func, E as intersection, k as iterator, ad as literal, q as map, _ as named, aj as never, a7 as nullType, a4 as number, o as object, r as record, al as regexp, s as set, a2 as string, av as symbol, y as tuple, a8 as undefinedType, w as union, af as unknown, aa as voidType } from './complex-90b7ed01.js';

declare const nullable: <TNode extends AnyBaseNode>(type: TNode) => UnionNode<[TNode, NullNode]>;
declare const optional: <TNode extends AnyBaseNode>(type: TNode) => UnionNode<[TNode, UndefinedNode]>;

type DefinitionMap = Map<string, AnyNode>;

declare const mapMultipleInnerNode: <TMapperResult>(node: AnyBaseNode & {
    types: AnyNode[];
}, mapper: (node: AnyNode) => TMapperResult) => TMapperResult[];
declare const mapObjectNode: <TMapperResult>(node: AnyObjectNode, mapper: (node: AnyNode) => TMapperResult) => (readonly [string, TMapperResult])[];
declare const serializePrimitive: (value: Primitive) => string;
declare const isNodeOptional: (node: AnyNode) => any;
declare const unionIfMultiple: <TNode extends AnyBaseNode>(nodes: [TNode, ...TNode[]]) => TNode | UnionNode<[TNode, ...TNode[]]>;
declare class UnsupportedError extends Error {
    readonly integration: string;
    readonly feature: string;
    constructor(integration: string, feature: string);
}

interface PrintNodeOptions {
    indent?: number;
    depth?: number;
}
/**
 * This method does not print an "optimized" version of the node in terms of
 * parentheses, indentation, etc. To get a pretty-printed version, use
 * `printNode` from `@onetyped/typescript` instead to get help from the compiler.
 */
declare function printNode(node: AnyNode, options?: PrintNodeOptions): string;

export { AnyBaseNode, AnyNode, AnyObjectNode, DefinitionMap, NullNode, UndefinedNode, UnionNode, UnsupportedError, isNodeOptional, mapMultipleInnerNode, mapObjectNode, nullable, optional, printNode, serializePrimitive, unionIfMultiple };
