import { Primitive } from './type-utils';
import { BaseNode } from './types';
export interface StringNode extends BaseNode<'string'> {
    readonly _type: string;
}
export declare const string: () => StringNode;
export interface NumberNode extends BaseNode<'number'> {
    readonly _type: number;
}
export declare const number: () => NumberNode;
export interface BooleanNode extends BaseNode<'boolean'> {
    readonly _type: boolean;
}
export declare const boolean: () => BooleanNode;
export interface NullNode extends BaseNode<'null'> {
    readonly _type: null;
}
export declare const nullType: () => NullNode;
export interface UndefinedNode extends BaseNode<'undefined'> {
    readonly _type: undefined;
}
export declare const undefinedType: () => UndefinedNode;
export interface VoidNode extends BaseNode<'void'> {
    readonly _type: void;
}
export declare const voidType: () => VoidNode;
export interface LiteralNode<Type extends Primitive> extends BaseNode<'literal'> {
    readonly _type: Type;
    type: Type;
}
export type AnyLiteralNode = LiteralNode<Primitive>;
export declare const literal: <Literal extends Primitive>(literal: Literal) => LiteralNode<Literal>;
export interface UnknownNode extends BaseNode<'unknown'> {
    readonly _type: unknown;
}
export declare const unknown: () => UnknownNode;
export interface AnyTypeNode extends BaseNode<'any'> {
    readonly _type: any;
}
export declare const any: () => AnyTypeNode;
export interface NeverNode extends BaseNode<'never'> {
    readonly _type: never;
}
export declare const never: () => NeverNode;
export interface RegexpNode extends BaseNode<'regexp'> {
    readonly _type: RegExp;
}
export declare const regexp: () => RegexpNode;
export interface BigIntNode extends BaseNode<'bigint'> {
    readonly _type: bigint;
}
export declare const bigint: () => BigIntNode;
export interface DateNode extends BaseNode<'date'> {
    readonly _type: Date;
}
export declare const date: () => DateNode;
export interface FileNode extends BaseNode<'file'> {
    readonly _type: File;
}
export declare const file: () => FileNode;
export interface BlobNode extends BaseNode<'blob'> {
    readonly _type: Blob;
}
export declare const blob: () => BlobNode;
export interface SymbolNode extends BaseNode<'symbol'> {
    readonly _type: symbol;
    readonly name: string;
}
export declare const symbol: (name: string) => SymbolNode;
//# sourceMappingURL=primitive.d.ts.map