import { AnyNamedNode, CircularNode, DefinitionReferenceNode } from './circular.js';
import { AnyArrayNode, AnyCustomNode, AnyFormDataNode, AnyFunctionNode, AnyIntersectionNode, AnyIteratorNode, AnyMapNode, AnyObjectNode, AnyRecordNode, AnySetNode, AnyTupleNode, AnyUnionNode } from './complex.js';
import { AnyLiteralNode, AnyTypeNode, BigIntNode, BlobNode, BooleanNode, DateNode, FileNode, NeverNode, NullNode, NumberNode, RegexpNode, StringNode, SymbolNode, UndefinedNode, UnknownNode, VoidNode } from './primitive.js';
declare const defaults: {};
type Defaults = typeof defaults;
export interface BaseNode<TypeName extends string> {
    readonly _type: any;
    typeName: TypeName;
}
export type AnyBaseNode = BaseNode<any>;
type AnyBasicNode = Omit<AnyBaseNode, keyof Defaults | '_type'> & {
    [Key in keyof Defaults]?: AnyBaseNode[Key];
};
export declare const defineNode: <T extends AnyBasicNode>(node: T) => T & {
    _type: any;
};
export type Infer<TNode extends AnyBaseNode> = TNode['_type'];
export type AnyNode = StringNode | NumberNode | BooleanNode | NullNode | UndefinedNode | AnyLiteralNode | UnknownNode | VoidNode | AnyTypeNode | NeverNode | RegexpNode | BigIntNode | DateNode | FileNode | BlobNode | SymbolNode | AnyCustomNode | AnyFormDataNode | AnyObjectNode | AnyArrayNode | AnySetNode | AnyRecordNode | AnyMapNode | AnyFunctionNode | AnyUnionNode | AnyTupleNode | AnyIntersectionNode | AnyNamedNode | AnyIteratorNode | DefinitionReferenceNode | CircularNode;
export type InferNodeArray<TNodes extends AnyBaseNode[], InferredTypes extends unknown[] = []> = TNodes extends [
    infer Head extends AnyBaseNode,
    ...infer Rest extends AnyBaseNode[]
] ? InferNodeArray<Rest, [...InferredTypes, Infer<Head>]> : InferredTypes;
export interface CustomTypeNode<TType> extends BaseNode<any> {
    _type: TType;
}
export {};
//# sourceMappingURL=types.d.ts.map